<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>GTSBox: /Users/dlekshmi/Desktop/Repos/PhD/GTSBox/Src/NLME/Auxiliary/logdet.m Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">GTSBox
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_413f4e031a85da0d68269c6fd2f76e1c.html">Src</a></li><li class="navelem"><a class="el" href="../../dir_8672bca13fc16af0e54d5ddc01090308.html">NLME</a></li><li class="navelem"><a class="el" href="../../dir_d544197a650feee977d1b0e201b59710.html">Auxiliary</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">logdet.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../dd/d8f/logdet_8m.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">function</span> v = <a class="code" href="../../dd/d8f/logdet_8m.html#a7fde3a5a9071ae7308862255be416ac1">logdet</a>(A, op)</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;%LOGDET Computation of logarithm of determinant of a matrix</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;%</div>
<div class="line"><a name="l00005"></a><span class="lineno"><a class="line" href="../../dd/d8f/logdet_8m.html#a7fde3a5a9071ae7308862255be416ac1">    5</a></span>&#160;%   v = <a class="code" href="../../dd/d8f/logdet_8m.html#a7fde3a5a9071ae7308862255be416ac1">logdet</a>(A);</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;%       computes the logarithm of determinant of A.</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;%</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;%       Here, A should be a square matrix of <span class="keywordtype">double</span> or single <span class="keyword">class</span>.</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;%       If A is singular, it will returns -inf.</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;%</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;%       Theoretically, <span class="keyword">this</span> <span class="keyword">function</span> should be functionally</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;%       equivalent to log(det(A)). However, it avoids the</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;%       overflow/underflow problems that are likely to</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;%       happen when applying det to large matrices.</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;%</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;%       The key idea is based on the mathematical fact that</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;%       the determinant of a triangular matrix equals the</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;%       product of its diagonal elements. Hence, the matrix<span class="stringliteral">&#39;s</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="stringliteral">%       log-determinant is equal to the sum of their logarithm</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="stringliteral">%       values. By keeping all computations in log-scale, the</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="stringliteral">%       problem of underflow/overflow caused by product of</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="stringliteral">%       many numbers can be effectively circumvented.</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="stringliteral">%</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="stringliteral">%       The implementation is based on LU factorization.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="stringliteral">%</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="stringliteral">%   v = logdet(A, &#39;</span>chol<span class="stringliteral">&#39;);</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="stringliteral">%       If A is positive definite, you can tell the function</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="stringliteral">%       to use Cholesky factorization to accomplish the task</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="stringliteral">%       using this syntax, which is substantially more efficient</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="stringliteral">%       for positive definite matrix.</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="stringliteral">%</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="stringliteral">%   Remarks</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="stringliteral">%   -------</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="stringliteral">%       logarithm of determinant of a matrix widely occurs in the</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="stringliteral">%       context of multivariate statistics. The log-pdf, entropy,</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="stringliteral">%       and divergence of Gaussian distribution typically comprises</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="stringliteral">%       a term in form of log-determinant. This function might be</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="stringliteral">%       useful there, especially in a high-dimensional space.</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="stringliteral">%</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="stringliteral">%       Theoretially, LU, QR can both do the job. However, LU</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="stringliteral">%       factorization is substantially faster. So, for generic</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="stringliteral">%       matrix, LU factorization is adopted.</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="stringliteral">%</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="stringliteral">%       For positive definite matrices, such as covariance matrices,</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="stringliteral">%       Cholesky factorization is typically more efficient. And it</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="stringliteral">%       is STRONGLY RECOMMENDED that you use the chol (2nd syntax above)</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="stringliteral">%       when you are sure that you are dealing with a positive definite</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="stringliteral">%       matrix.</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="stringliteral">%</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="stringliteral">%   Examples</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="stringliteral">%   --------</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="stringliteral">%       % compute the log-determinant of a generic matrix</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="stringliteral">%       A = rand(1000);</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="stringliteral">%       v = logdet(A);</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="stringliteral">%</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="stringliteral">%       % compute the log-determinant of a positive-definite matrix</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="stringliteral">%       A = rand(1000);</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="stringliteral">%       C = A * A&#39;</span>;     % <span class="keyword">this</span> makes C positive definite</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;%       v = <a class="code" href="../../dd/d8f/logdet_8m.html#a7fde3a5a9071ae7308862255be416ac1">logdet</a>(C, <span class="stringliteral">&#39;chol&#39;</span>);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;%</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;%   Copyright 2008, Dahua Lin, MIT</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;%   Email: dhlin@mit.edu</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;%</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;%   This file can be freely modified or distributed <span class="keywordflow">for</span> any kind of</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;%   purposes.</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;%</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;%% argument checking</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;assert(isfloat(A) &amp;&amp; ndims(A) == 2 &amp;&amp; size(A,1) == size(A,2), ...</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="stringliteral">&#39;logdet:invalidarg&#39;</span>, ...</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="stringliteral">&#39;A should be a square matrix of double or single class.&#39;</span>);</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="keywordflow">if</span> nargin &lt; 2</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    use_chol = 0;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="keywordflow">else</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    assert(strcmpi(op, <span class="stringliteral">&#39;chol&#39;</span>), ...</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="stringliteral">&#39;logdet:invalidarg&#39;</span>, ...</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <span class="stringliteral">&#39;The second argument can only be a string &#39;</span><span class="stringliteral">&#39;chol&#39;</span><span class="stringliteral">&#39; if it is specified.&#39;</span>);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    use_chol = 1;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;end</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;%% computation</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keywordflow">if</span> use_chol</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    v = 2 * sum(log(diag(chol(A))));</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="keywordflow">else</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    [L, U, P] = lu(A);</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    du = diag(U);</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    c = det(P) * prod(sign(du));</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    v = log(c) + sum(log(abs(du)));</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;end</div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="alogdet_8m_html_a7fde3a5a9071ae7308862255be416ac1"><div class="ttname"><a href="../../dd/d8f/logdet_8m.html#a7fde3a5a9071ae7308862255be416ac1">logdet</a></div><div class="ttdeci">function logdet(in A, in op)</div><div class="ttdoc">Computes the log determininant, this code is taken from https://github.com/jluttine/matlab/blob/maste...</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Dec 3 2020 14:53:29 for GTSBox by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
